Index: src/edu/ucsb/nceas/metacat/AuthLdap.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AuthLdap.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/AuthLdap.java	(revision 4080)
@@ -50,6 +50,10 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
+import java.lang.InstantiationException;
 import java.net.URLDecoder;
 import java.util.Iterator;
 import java.util.HashMap;
@@ -65,7 +69,6 @@
  * is authenticated, and whether they are a member of a particular group.
  */
 public class AuthLdap implements AuthInterface {
-  private MetaCatUtil util = new MetaCatUtil();
   private String ldapUrl;
   private String ldapsUrl;
   private String ldapBase;
@@ -83,34 +86,48 @@
 
   private static Logger logMetacat = Logger.getLogger(AuthLdap.class);
   
-  /**
-   * Construct an AuthLdap
-   */
-  public AuthLdap() {
-    // Read LDAP URI for directory service information
-    this.ldapUrl = MetaCatUtil.getOption("ldapurl");
-    this.ldapsUrl = MetaCatUtil.getOption("ldapsurl");
-    this.ldapBase = MetaCatUtil.getOption("ldapbase");
-    this.referral = MetaCatUtil.getOption("referral");
-    this.ldapConnectTimeLimit = 
-      MetaCatUtil.getOption("ldapconnecttimelimit");
-    this.ldapSearchTimeLimit = Integer.parseInt(
-      MetaCatUtil.getOption("ldapsearchtimelimit"));
-    this.ldapSearchCountLimit = Integer.parseInt(
-      MetaCatUtil.getOption("ldapsearchcountlimit"));
-    
-    // Store referral info for use in building group DNs in getGroups() 
-    this.currentReferralInfo = "";
-  }
+    /**
+	 * Construct an AuthLdap
+	 */
+	public AuthLdap() throws InstantiationException {
+		// Read LDAP URI for directory service information
+		try {
+			this.ldapUrl = PropertyService.getProperty("ldap.url");
+			this.ldapsUrl = PropertyService.getProperty("ldap.surl");
+			// use the NCEAS base as a fallback.  Normally, the base will be
+			// parsed from the user during authentication
+			this.ldapBase = PropertyService.getProperty("ldap.base.NCEAS");
+			this.referral = PropertyService.getProperty("ldap.referral");
+			this.ldapConnectTimeLimit = PropertyService
+					.getProperty("ldap.connectTimeLimit");
+			this.ldapSearchTimeLimit = Integer.parseInt(PropertyService
+					.getProperty("ldap.searchTimeLimit"));
+			this.ldapSearchCountLimit = Integer.parseInt(PropertyService
+					.getProperty("ldap.searchCountLimit"));
+		} catch (PropertyNotFoundException pnfe) {
+			throw new InstantiationException(
+					"Could not instantiate AuthLdap.  Property not found: "
+							+ pnfe.getMessage());
+		} catch (NumberFormatException nfe) {
+			throw new InstantiationException(
+					"Could not instantiate AuthLdap.  Bad number format when converting properties: "
+							+ nfe.getMessage());
+		}
 
+		// Store referral info for use in building group DNs in getGroups()
+		this.currentReferralInfo = "";
+	}
+
   /**
-   * Determine if a user/password are valid according to the authentication
-   * service.
-   *
-   * @param user the name of the principal to authenticate
-   * @param password the password to use for authentication
-   * @returns boolean true if authentication successful, false otherwise
-   */
+	 * Determine if a user/password are valid according to the authentication
+	 * service.
+	 * 
+	 * @param user
+	 *            the name of the principal to authenticate
+	 * @param password
+	 *            the password to use for authentication
+	 * @returns boolean true if authentication successful, false otherwise
+	 */
   
   public boolean authenticate(String user, String password) throws 
     ConnectException {
@@ -134,7 +151,7 @@
         logMetacat.info("with user as identifier: " + identifier);
 
         authenticated = ldapAuthenticate(identifier, password, 
-        		(new Boolean(MetaCatUtil.getOption("onlySecureLDAPConnection"))).booleanValue());
+        		(new Boolean(PropertyService.getProperty("ldap.onlySecureConnection"))).booleanValue());
         // if not found, try looking up a valid DN then auth again
         if (!authenticated) {
         	logMetacat.info("Not Authenticated");
@@ -167,7 +184,7 @@
         		logMetacat.info("and refBase as: " + refBase);
 
         		authenticated = ldapAuthenticate(identifier, password, refUrl, refBase,
-                		(new Boolean(MetaCatUtil.getOption("onlySecureLDAPReferalsConnection")))
+                		(new Boolean(PropertyService.getProperty("ldap.onlySecureReferalsConnection")))
                 			.booleanValue());
         	} else {
         		logMetacat.info("identifier doesnt start with ldap");
@@ -177,7 +194,7 @@
         		logMetacat.info("with user as identifier: " + identifier);
         		
         		authenticated = ldapAuthenticate(identifier, password,
-            		(new Boolean(MetaCatUtil.getOption("onlySecureLDAPConnection"))).booleanValue());
+            		(new Boolean(PropertyService.getProperty("ldap.onlySecureConnection"))).booleanValue());
         	}
         }
     } catch (NullPointerException e) {
@@ -358,40 +375,23 @@
           for (boolean moreReferrals = true; moreReferrals;) {
               try {
                   // Perform the search
-            	  logMetacat.debug("before searching for DNs with following filter: " + filter);
-            	  //logMetacat.debug("the context name space is ====== "+sctx.getNameInNamespace());
                   NamingEnumeration answer = 
                       sctx.search("", filter, ctls);
-                  logMetacat.debug("after searching for DNs with following filter: " + filter);
+
                   // Return the answer
                   while (answer.hasMore()) {
-                	  logMetacat.debug("In anwer.hasMore() while loop");
                       SearchResult sr = (SearchResult)answer.next();
                       identifier = sr.getName();
-                      logMetacat.debug("after anwer.hasMore() while loop "+identifier);
                       return identifier;
                   }
                   // The search completes with no more referrals
                   moreReferrals = false;
               } catch (ReferralException e) {
-            	  logMetacat.warn("Got referral: " + e.getReferralInfo());
+            	  logMetacat.info("Got referral: " + e.getReferralInfo());
             	  // Point to the new context from the referral
-            	  //DirContext storedConext = sctx;
-            	  try
-            	  {
-	                  if (moreReferrals) {
-	                      sctx = (DirContext) e.getReferralContext();
-	                  }
-            	  }
-            	  catch(Exception ee)
-            	  {
-            		   e.skipReferral();
-            		   if (moreReferrals) {
- 	                      sctx = (DirContext) e.getReferralContext();
- 	                   }
-            		   logMetacat.warn("Naming exception while setting context to referral: " + ee);
-            	  }
-                  logMetacat.debug("after reset new context " + e.getReferralInfo());
+                  if (moreReferrals) {
+                      sctx = (DirContext) e.getReferralContext();
+                  }
               }
           }
       } catch (NamingException e) {
@@ -847,8 +847,8 @@
                 }
                 
               } catch (NamingException nameEx){
-                logMetacat.debug("Caught naming exception1: "+nameEx.getMessage());
-                //nameEx.printStackTrace(System.err);
+                logMetacat.debug("Caught naming exception: ");
+                nameEx.printStackTrace(System.err);
               }
             }
           }// end while
@@ -865,19 +865,7 @@
           
           // set moreReferrals to true and set the referral context
           moreReferrals = true;
-          try
-          {
-              ctx = (DirContext) re.getReferralContext();
-          }
-          catch(Exception ee)
-    	  {
-    		   re.skipReferral();
-    		   if (moreReferrals) {
-                   ctx = (DirContext) re.getReferralContext();
-                }
-    		   logMetacat.error("Naming exception while setting context to referral: " + ee);
-    	  }
-          logMetacat.debug("after reset new context in referral in getGroups " );
+          ctx = (DirContext) re.getReferralContext();
            
         }// end inner try
       }// end for
@@ -889,8 +877,8 @@
     } catch (NamingException e) {
       
       // naming exceptions get logged, groups are returned
-      logMetacat.info("In AuthLdap.getGroups()2, caught naming exception: "+e.getMessage());
-      //e.printStackTrace(System.err);
+      logMetacat.info("In AuthLdap.getGroups(), caught naming exception: ");
+      e.printStackTrace(System.err);
       
     } finally {
       // once all referrals are followed, report and return the groups found
@@ -1220,112 +1208,168 @@
     return -1;
   }
 
-  /**
-   * Test method for the class
-   */
-  public static void main(String[] args) {
+  public void testCredentials(String dn, String password, 
+		    String rootServer, String rootBase ) throws NamingException {
+	  
+	  String server = "";
+	  String userDN = "";
+	  logMetacat.debug("dn is: " + dn);
 
-    // Provide a user, such as: "Matt Jones", or "jones"
-    String user = args[0];
-    String password = args[1];
+	  int position = dn.lastIndexOf("/");
+      logMetacat.debug("position is: " + position);
+	  if (position == -1) {
+		  server = rootServer;
+		  if(dn.indexOf(userDN) < 0){
+			  userDN = dn + "," + rootBase;
+		  } else {
+			  userDN = dn;
+		  }
+		  logMetacat.debug("userDN is: " + userDN);
 
-    logMetacat.warn("Creating session...");
-    AuthLdap authservice = new AuthLdap();
-    logMetacat.warn("Session exists...");
+       } else {
+		  server = dn.substring(0, position+1);
+		  userDN = dn.substring(position+1);
+		  logMetacat.debug("server is: " + server);
+		  logMetacat.debug("userDN is: " + userDN);
+	   }
+		          
+	   logMetacat.debug("Trying to authenticate: " + userDN);
+	   logMetacat.debug("          Using server: " + server);
 
-    boolean isValid = false;
-    try {
-      logMetacat.warn("Authenticating...");
-      isValid = authservice.authenticate(user, password);
-      if (isValid) {
-    	  logMetacat.warn("Authentication successful for: " + user);
-      }
-      else {
-        logMetacat.warn("Authentication failed for: " + user);
-      }
+///*	   try { 
+			LdapContext ctx = null;
+			   
+			env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
+	        env.put(Context.REFERRAL, "follow");
+			env.put(Context.SECURITY_AUTHENTICATION, "simple");
+			env.put(Context.SECURITY_PRINCIPAL, userDN);
+			env.put(Context.SECURITY_CREDENTIALS, password);
+			env.put(Context.PROVIDER_URL, rootServer);
 
-      // Get attributes for the user
-      if (isValid) {
-        logMetacat.info("\nGetting attributes for user....");
-        HashMap userInfo = authservice.getAttributes(user, password, user);
-        // Print all of the attributes
-        Iterator attList = (Iterator) ( ( (Set) userInfo.keySet()).iterator());
-        while (attList.hasNext()) {
-          String att = (String) attList.next();
-          Vector values = (Vector) userInfo.get(att);
-          Iterator attvalues = values.iterator();
-          while (attvalues.hasNext()) {
-            String value = (String) attvalues.next();
-            logMetacat.warn(att + ": " + value);
-          }
-        }
-      }
+			ctx = new InitialLdapContext(env, null);
 
-      // get the groups
-      if (isValid) {
-        logMetacat.warn("\nGetting all groups....");
-        String[][] groups = authservice.getGroups(user, password);
-        logMetacat.info("Groups found: " + groups.length);
-        for (int i = 0; i < groups.length; i++) {
-          logMetacat.info("Group " + i + ": " + groups[i][0]);
-        }
-      }
 
-      // get the groups for the user
-      String savedGroup = null;
-      if (isValid) {
-        logMetacat.warn("\nGetting groups for user....");
-        String[][] groups = authservice.getGroups(user, password, user);
-        logMetacat.info("Groups found: " + groups.length);
-        for (int i = 0; i < groups.length; i++) {
-          logMetacat.info("Group " + i + ": " + groups[i][0]);
-          savedGroup = groups[i][0];
-        }
-      }
+		
+  }
+   
+    /**
+	 * Test method for the class
+	 */
+	public static void main(String[] args) {
 
-      // get the users for a group
-      if (isValid) {
-        logMetacat.warn("\nGetting users for group....");
-        logMetacat.info("Group: " + savedGroup);
-        String[] users = authservice.getUsers(user, password, savedGroup);
-        logMetacat.info("Users found: " + users.length);
-        for (int i = 0; i < users.length; i++) {
-          logMetacat.warn("User " + i + ": " + users[i]);
-        }
-      }
+		// Provide a user, such as: "Matt Jones", or "jones"
+		String user = args[0];
+		String password = args[1];
+		String org = args[2];
 
-      // get all users
-      if (isValid) {
-        logMetacat.warn("\nGetting all users ....");
-        String[][] users = authservice.getUsers(user, password);
-        logMetacat.info("Users found: " + users.length);
+		logMetacat.warn("Creating session...");
+		AuthLdap authservice = null;
+		try {
+			authservice = new AuthLdap();
+		} catch (Exception e) {
+			logMetacat.error("Could not instantiate AuthLdap: "
+					+ e.getMessage());
+			return;
+		}
+		logMetacat.warn("Session exists...");
 
-      }
+		boolean isValid = false;
+		try {
+			logMetacat.warn("Authenticating...");
+			isValid = authservice.authenticate(user, password);
+			if (isValid) {
+				logMetacat.warn("Authentication successful for: " + user);
+			} else {
+				logMetacat.warn("Authentication failed for: " + user);
+			}
 
-      // get the whole list groups and users in XML format
-      if (isValid) {
-        logMetacat.warn("\nTrying principals....");
-        authservice = new AuthLdap();
-        String out = authservice.getPrincipals(user, password);
-        java.io.File f = new java.io.File("principals.xml");
-        java.io.FileWriter fw = new java.io.FileWriter(f);
-        java.io.BufferedWriter buff = new java.io.BufferedWriter(fw);
-        buff.write(out);
-        buff.flush();
-        buff.close();
-        fw.close();
-        logMetacat.warn("\nFinished getting principals.");
-      }
+			// Get attributes for the user
+			if (isValid) {
+				logMetacat.info("\nGetting attributes for user....");
+				HashMap userInfo = authservice.getAttributes(user, password,
+						user);
+				// Print all of the attributes
+				Iterator attList = (Iterator) (((Set) userInfo.keySet())
+						.iterator());
+				while (attList.hasNext()) {
+					String att = (String) attList.next();
+					Vector values = (Vector) userInfo.get(att);
+					Iterator attvalues = values.iterator();
+					while (attvalues.hasNext()) {
+						String value = (String) attvalues.next();
+						logMetacat.warn(att + ": " + value);
+					}
+				}
+			}
 
-    }
-    catch (ConnectException ce) {
-      logMetacat.error(ce.getMessage());
-    }
-    catch (java.io.IOException ioe) {
-      logMetacat.error("I/O Error writing to file principals.txt");
-    }
-  }
+			// get the groups
+			if (isValid) {
+				logMetacat.warn("\nGetting all groups....");
+				String[][] groups = authservice.getGroups(user, password);
+				logMetacat.info("Groups found: " + groups.length);
+				for (int i = 0; i < groups.length; i++) {
+					logMetacat.info("Group " + i + ": " + groups[i][0]);
+				}
+			}
 
+			// get the groups for the user
+			String savedGroup = null;
+			if (isValid) {
+				logMetacat.warn("\nGetting groups for user....");
+				String[][] groups = authservice.getGroups(user, password, user);
+				logMetacat.info("Groups found: " + groups.length);
+				for (int i = 0; i < groups.length; i++) {
+					logMetacat.info("Group " + i + ": " + groups[i][0]);
+					savedGroup = groups[i][0];
+				}
+			}
+
+			// get the users for a group
+			if (isValid) {
+				logMetacat.warn("\nGetting users for group....");
+				logMetacat.info("Group: " + savedGroup);
+				String[] users = authservice.getUsers(user, password,
+						savedGroup);
+				logMetacat.info("Users found: " + users.length);
+				for (int i = 0; i < users.length; i++) {
+					logMetacat.warn("User " + i + ": " + users[i]);
+				}
+			}
+
+			// get all users
+			if (isValid) {
+				logMetacat.warn("\nGetting all users ....");
+				String[][] users = authservice.getUsers(user, password);
+				logMetacat.info("Users found: " + users.length);
+
+			}
+
+			// get the whole list groups and users in XML format
+			if (isValid) {
+				logMetacat.warn("\nTrying principals....");
+				authservice = new AuthLdap();
+				String out = authservice.getPrincipals(user, password);
+				java.io.File f = new java.io.File("principals.xml");
+				java.io.FileWriter fw = new java.io.FileWriter(f);
+				java.io.BufferedWriter buff = new java.io.BufferedWriter(fw);
+				buff.write(out);
+				buff.flush();
+				buff.close();
+				fw.close();
+				logMetacat.warn("\nFinished getting principals.");
+			}
+
+		} catch (ConnectException ce) {
+			logMetacat.error(ce.getMessage());
+		} catch (java.io.IOException ioe) {
+			logMetacat.error("I/O Error writing to file principals.txt: "
+					+ ioe.getMessage());
+		} catch (InstantiationException ie) {
+			logMetacat.error("Instantiation error writing to file principals.txt: "
+							+ ie.getMessage());
+		}
+	}
+
   /**
    * This method will be called by start a thread.
    * It can handle if a referral exception happend.
Index: src/edu/ucsb/nceas/metacat/AccessControlForSingleFile.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AccessControlForSingleFile.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/AccessControlForSingleFile.java	(revision 4080)
@@ -36,7 +36,9 @@
 import java.net.MalformedURLException;
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
 
+
 /** 
  * A Class that loads eml-access.xml file containing ACL for a metadata
  * document into relational DB. It extends DefaultHandler class to handle
Index: src/edu/ucsb/nceas/metacat/harvesterClient/HarvesterRegistration.java
===================================================================
--- src/edu/ucsb/nceas/metacat/harvesterClient/HarvesterRegistration.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/harvesterClient/HarvesterRegistration.java	(revision 4080)
@@ -750,10 +750,10 @@
       System.out.println("Error in loading options: " + e.getMessage());
     }
     
-    dbDriver = options.getOption("dbDriver");
-    defaultDB = options.getOption("defaultDB");
-    password = options.getOption("password");
-    user = options.getOption("user");
+    dbDriver = options.getOption("database.driver");
+    defaultDB = options.getOption("database.connectionURI");
+    password = options.getOption("database.password");
+    user = options.getOption("database.user");
 
     // Load the jdbc driver
     try {
Index: src/edu/ucsb/nceas/metacat/DBConnectionPool.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBConnectionPool.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBConnectionPool.java	(revision 4080)
@@ -37,6 +37,9 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 /** 
  * A class represent a DBConnection pool. Another user can use the
  * object to initial a connection pool, get db connection or return it.
@@ -53,36 +56,69 @@
   private static int countOfReachMaximum = 0;
   private static Logger logMetacat = Logger.getLogger(DBConnectionPool.class);
 
-  //maximum connection number in the connection pool
-  final static int MAXIMUMCONNECTIONNUMBER=
-                  Integer.parseInt(MetaCatUtil.getOption("maximumConnections"));
+  private static int maxConnNum;
+  private static int initConnNum;
+  private static int incrConnNum;
+  private static long maxAge;
+  private static long maxConnTime;
+  private static int maxUsageNum;
+  private static String dbConnRecyclThrd;
+  private static long cyclTimeDbConn;
   
-  //inintila connection number int the connection pool
-  final static int INITIALCONNECTIONNUMBER=
-                  Integer.parseInt(MetaCatUtil.getOption("initialConnections"));
- 
-  //the number to increase connection pool size
-  final static int INCREASECONNECTIONNUMBER=
-                Integer.parseInt(MetaCatUtil.getOption("incrementConnections"));
-                
-  //maximum age for a connection (in milli seconds)
-  final static long MAXIMUMAGE =
-                  Long.parseLong(MetaCatUtil.getOption("maximumConnectionAge"));
-  //maximum connection time for a connection ( in milli second)
-  final static long MAXIMUMCONNECTIONTIME =
-                 Long.parseLong(MetaCatUtil.getOption("maximumConnectionTime"));
-  //maximum number for using a connection.
-  final static int MAXIMUMUSAGENUMBER =
-                  Integer.parseInt(MetaCatUtil.getOption("maximumUsageNumber"));
-  //the parameter if run dbconncestionrecyclethread or not
-  final static String DBCONNECTIONRECYCLETHREAD =
-                          MetaCatUtil.getOption("runDBConnectionRecycleThread");
-  //the cycle time of connection recycle action
-  final static long CYCLETIMEOFDBCONNECTION = 
-               Long.parseLong(MetaCatUtil.getOption("cycleTimeOfDBConnection"));
-               
-  //the number for trying to check out a connection in the pool in 
-  //getDBConnection method
+  final static int MAXIMUMCONNECTIONNUMBER;
+  final static int INITIALCONNECTIONNUMBER;
+  final static int INCREASECONNECTIONNUMBER;
+  final static long MAXIMUMAGE;
+  final static long MAXIMUMCONNECTIONTIME;
+  final static int MAXIMUMUSAGENUMBER;
+  final static String DBCONNECTIONRECYCLETHREAD ;
+  final static long CYCLETIMEOFDBCONNECTION;
+  
+  static {
+		int maxConnNum = 0;
+		int initConnNum = 0;
+		int incrConnNum = 0;
+		long maxAge = 0;
+		long maxConnTime = 0;
+		int maxUsageNum = 0;
+		String dbConnRecyclThrd = null;
+		long cyclTimeDbConn = 0;
+		
+		try {
+			// maximum connection number in the connection pool
+			maxConnNum = Integer.parseInt(PropertyService
+					.getProperty("database.maximumConnections"));
+			initConnNum = Integer.parseInt(PropertyService
+					.getProperty("database.initialConnections"));
+			incrConnNum = Integer.parseInt(PropertyService
+					.getProperty("database.incrementConnections"));
+			maxAge = Integer.parseInt(PropertyService
+					.getProperty("database.maximumConnections"));
+			maxConnTime = Long.parseLong(PropertyService
+					.getProperty("database.maximumConnectionTime"));
+			maxUsageNum = Integer.parseInt(PropertyService
+					.getProperty("database.maximumUsageNumber"));
+			dbConnRecyclThrd = PropertyService
+					.getProperty("database.runDBConnectionRecycleThread");
+			cyclTimeDbConn = Long.parseLong(PropertyService
+					.getProperty("database.cycleTimeOfDBConnection"));
+		} catch (PropertyNotFoundException pnfe) {
+			System.err.println("Could not get property in static block: "
+					+ pnfe.getMessage());
+		}
+		
+		MAXIMUMCONNECTIONNUMBER = maxConnNum;
+		INITIALCONNECTIONNUMBER = initConnNum;
+		INCREASECONNECTIONNUMBER = incrConnNum;
+		MAXIMUMAGE = maxAge;
+		MAXIMUMCONNECTIONTIME = maxConnTime;
+		MAXIMUMUSAGENUMBER = maxUsageNum;
+		DBCONNECTIONRECYCLETHREAD  = dbConnRecyclThrd;
+		CYCLETIMEOFDBCONNECTION = cyclTimeDbConn;
+	}
+  
+  // the number for trying to check out a connection in the pool in
+  // getDBConnection method
   final static int LIMIT = 2;
   
   final static int FREE = 0; //status of a connection
